package praxis;

import java.util.Properties;
import javax.mail.*;
import javax.mail.internet.*;
import javax.activation.*;

/**
 * Title:        Attachments in JavaMail
 * Description:  Beispiel fr die Behandlung von Attachments in JavaMail
 */

public class Attach {
	private static final boolean DEBUG = true;
	public static void main(String args[]) throws Exception {
		String host, from, to, file;
		if (args.length < 4) {
			host = "smtp.swissonline.ch";
			from = "joller@joller-voss.ch";
			to = "joller@joller-voss.ch";
			file = "Glider.bmp";
		} else {
			host = args[0];
			from = args[1];
			to = args[2];
			file = args[3]; 
		}
		if (DEBUG) {
			System.out.println("=====================================");
			System.out.println("[main]Host  " + host);
			System.out.println("[main]from  " + from);
			System.out.println("[main]to    " + to);
			System.out.println("[main]File  " + file);
			System.out.println("=====================================");
		}

		// Bestimmen / Setzen der System Eigenschaften
		if (DEBUG) System.out.println("[main]Properties setzen");
		Properties props = System.getProperties();

		// Angaben zum Mail Server
		props.put("mail.smtp.host", host);

		// bestimmen der Session / Instanzieren der Session Klasse
		Session session = Session.getInstance(props, null);
		session.setDebug(false);

		// Definieren der Message
		Message message = new MimeMessage(session);
		message.setFrom(new InternetAddress(from));
		message.addRecipient(Message.RecipientType.TO, new InternetAddress(to));
		String line="Hallo JavaMail Attachment";
		if (DEBUG) System.out.println("[main]Subject:"+line);
		message.setSubject(line);

		// Kreieren der Message Bestandteile
		BodyPart messageBodyPart = new MimeBodyPart();

		// Eingabe der Meldung
		line="Auch mir geht's gut!";
		messageBodyPart.setText("Auch mir geht's gut!");
		if (DEBUG) System.out.println("[main]Body:"+line);

		// Kreieren der Multipart Message
		Multipart multipart = new MimeMultipart();

		// Part 1 hinzufgen
		multipart.addBodyPart(messageBodyPart);

		// Part 2 (Attachment) hinzufgen
		if (DEBUG) System.out.println("[main]Body:Attachment");

		// kreieren eines Multiparts
		messageBodyPart = new MimeBodyPart();

		// bestimmen der Attachments
		DataSource source = new FileDataSource(file);

		// setzen des Data Handlers auf das Attachment
		messageBodyPart.setDataHandler(new DataHandler(source));

		// setzen des Dateinamens
		messageBodyPart.setFileName(file);

		// Teil zwei hinzufgen
		multipart.addBodyPart(messageBodyPart);

		// Teile zu einer Message zusammenfgen
		message.setContent(multipart);

		// senden der Message
		Transport.send(message);
		if (DEBUG) System.out.println("[main]Ende");
	}
}
