package praxis;

import java.util.Properties;

import javax.activation.DataHandler;
import javax.activation.DataSource;
import javax.activation.FileDataSource;
import javax.mail.BodyPart;
import javax.mail.Message;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;

/**
 * Title:        JavaMail einer HTML Seite mit Image
 * Description:  Senden einer HTML Seite, mit Bild, als eine JavaMail Message (Multipart Message mit Content ID fr das Attachment).
 */

public class HTMLmitImageMessage {
	public static final boolean DEBUG=true;
	public static void main(String args[]) throws Exception {
		String host,from,to,file;
		if (args.length<4) {
			host="smtp.swissonline.ch";
			from="joller@joller-voss.ch";
			to = "joller@joller-voss.ch";
			file="Glider.bmp";
		} else {
			host = args[0];
			from = args[1];
			to = args[2];
			file = args[3]; //javalogo52x88.gif
		}
		if (DEBUG) {
			System.out.println("=====================================");
			System.out.println("[main]Host  "+host);
			System.out.println("[main]from  "+from);
			System.out.println("[main]to    "+to);
			System.out.println("[main]File  "+file);
			System.out.println("=====================================");
		}
	
		System.out.println("[main]Properties setzen");
		// Bestimmen der System Properties
		Properties props = System.getProperties();
		// Mail Server
		props.put("mail.smtp.host", host);

		// Session
		Session session = Session.getDefaultInstance(props, null);

		// Message
		Message message = new MimeMessage(session);

		// Headers
		String line="mit Bild im Anhang (kein Virus)";
		if (DEBUG) System.out.println("[main]setSubject("+line+")");
		message.setSubject(line);
		message.setFrom(new InternetAddress(from));
		message.addRecipient(Message.RecipientType.TO, 
				new InternetAddress(to));

		// Message Parts
		BodyPart messageBodyPart = new MimeBodyPart();

		// HTML Inhalt mit Referenz auf das Attachment (Bild)
		String htmlText = "<H1>Danke</H1>" + 
							"<img src=\"cid:bild\">";

		// Content des Body Parts
		if (DEBUG) System.out.println("[main]setContent("+htmlText+")");
		messageBodyPart.setContent(htmlText, "text/html");

		// Multipart definieren 
		MimeMultipart multipart = new MimeMultipart("related");

		// Body Part dem Multipart hinzufgen
		multipart.addBodyPart(messageBodyPart);

		// Image Part definieren
		messageBodyPart = new MimeBodyPart();

		// Lesen des Images und Zuordnung an den Part
		DataSource fds = new FileDataSource(file);
		messageBodyPart.setDataHandler(new DataHandler(fds));

		// Header Verbindung zum HTML: wie beim Header
		messageBodyPart.setHeader("Content-ID", "bild"); 

		// Dem Multipart Objekt hinzufgen
		multipart.addBodyPart(messageBodyPart);

		// Multipart mit Message assoziieren
		message.setContent(multipart);

		// Message senden
		if (DEBUG) System.out.println("[main]send(message)");
		Transport.send(message);
		if (DEBUG) System.out.println("[main]Ende");
	}
}
