package praxis;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Properties;

import javax.mail.Folder;
import javax.mail.Session;
import javax.mail.Store;

public class Lesen {
	public static void main(String args[]) throws Exception {
		/*
		  String host = args[0];
		  String username = args[1];
		  String password = args[2];
		*/
		String setup[] =
			{ "mail.swissonline.ch", "UID", "PWD" };
		// 1) Properties bestimmen oder setzen
		Properties props = new Properties();
		String host = setup[0];
		String username = setup[1];
		String password = setup[2];

		// 1.a) System Properties bestimmen (Argumente)
		// Properties props = System.getProperties();

		// 2) Mailbox Server festlegen
		props.put("mail.pop3.host", host);

		// 3) Session kreieren
		Session session = Session.getDefaultInstance(props, null);
		session.setDebug(true);

		// 4) Mailbox festlegen (store)
		Store store = session.getStore("pop3");//protocol (imap, pop3)

		// 4.1) Verbindung zur Mailbox aufbauen
		store.connect(host, username, password);

		// 4.2) Folder / Mailbox bestimmen
		Folder folder = store.getFolder("INBOX");

		// 4.3) Mailbox read-only (lesend) ffnen
		folder.open(Folder.READ_ONLY);

		BufferedReader reader =
			new BufferedReader(new InputStreamReader(System.in));

		// 5) Directory bestimmen
		javax.mail.Message[] message = folder.getMessages();

		for (int i = 0, n = message.length; i < n; i++) {

			// 6) Inhalt 
			// 6.1) von Subject und From Feld anzeigen
			System.out.println(
				i
					+ ": "
					+ message[i].getFrom()[0]
					+ "\t"
					+ message[i].getSubject());
			System.out.println(
				"Moechten Sie die Nachricht lesen? [JA zum Lesen/QUIT falls nicht]");
			String line = reader.readLine();
			if ("JA".equals(line)) {

				// 6.2) Message Inhalt anzeigen
				System.out.println(message[i].getContent());

			} else if ("QUIT".equals(line)) {
				break;
			}
		}
		folder.close(false);
		store.close();
	}
}