package praxis;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.util.Properties;

import javax.mail.Folder;
import javax.mail.Message;
import javax.mail.Session;
import javax.mail.Store;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;
/**
 * Title:        Beantworten einer Mail Message
 * Description:  Beispiel fr den Einsatz der reply() Methode
 */

public class Reply {
	private static final String
		SMTP_HOST="smtp.host.ch", 
		POP3_HOST="pop.host.ch", 
		USER="user",
		PWD="*******",
		REPLY_FROM="user@host.ch";
	public static void main(String args[]) throws Exception {
		String pop3Host, smtpHost, username, password, from;
		if (args.length<4) {
			smtpHost = SMTP_HOST;
			pop3Host = POP3_HOST;
			username = USER;
			password = PWD;
			from = REPLY_FROM; 
		} else {
			smtpHost = args[0];
			pop3Host = args[1];
			username = args[2];
			password = args[3];
			from = args[4];
		}

		// leere Properties : Zielhost (der Antwort)
		System.out.println("[Reply]Setzen der Properties");
		Properties props = System.getProperties();
		props.put("mail.smtp.host", smtpHost);

		// Bestimmen der Session
		System.out.println("[Reply]Session  instanzieren");
		Session session = Session.getDefaultInstance(props, null);
		session.setDebug(true);

		// und des Stores (Host mit den Mails: POP3)
		System.out.println("[Reply]Store  instanzieren");
		Store store = session.getStore("pop3");
		store.connect(pop3Host, username, password);

		// und des Folders
		System.out.println("[Reply]Folder  instanzieren");
		Folder folder = store.getFolder("INBOX");
		folder.open(Folder.READ_ONLY);

		BufferedReader reader =
			new BufferedReader(new InputStreamReader(System.in));

		// Message Verzeichnis bestimmen
		System.out.println("[Reply]Message Verzeichnis");
		Message message[] = folder.getMessages();
		if (message.length < 1)
			System.out.println("[Reply]\tMessage Verzeichnis ist leer");
		for (int i = 0, n = message.length; i < n; i++) {
			System.out.println(
				i
					+ ": "
					+ message[i].getFrom()[0]
					+ "\t"
					+ message[i].getSubject());

			System.out.println(
				"Wollen Sie auf diese Meldung antworten? [JA oder/QUIT]");
			String line = reader.readLine();
			if ("JA".equals(line)) {

				// Antwort Message Objekt
				MimeMessage reply = (MimeMessage) message[i].reply(false);

				// 'From' Feld
				reply.setFrom(new InternetAddress(from));

				// Inhalt der Antwort (der alte Text wird hineinkopiert)
				//        Aber es wird nur Text kopiert
				MimeMessage orig = (MimeMessage) message[i];
				StringBuffer buffer = new StringBuffer("Danke\n\n");
				if (orig.isMimeType("text/plain")) {
					String content = (String) orig.getContent();
					StringReader contentReader = new StringReader(content);
					BufferedReader br = new BufferedReader(contentReader);
					String contentLine;
					while ((contentLine = br.readLine()) != null) {
						buffer.append("> ");
						buffer.append(contentLine);
						buffer.append("\r\n");
					}
				}

				// setzen des Inhalts
				reply.setText(buffer.toString());

				// senden der Meldung
				Transport.send(reply);

			} else if ("QUIT".equals(line)) {
				break;
			}
		}

		// Connection schliessen
		System.out.println("[Reply]Folder schliessen");
		folder.close(false); // kein purge der Meldungen
		System.out.println("[Reply]Store schliessen");
		store.close();
		System.out.println("[main]ENDE");
	}
}
