/*
 * Created on 29.02.2004
 * TelnetMail
 *
*/
package telnet;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.Socket;
import java.net.UnknownHostException;

/**
 * @author jjoller
 *
 */
public class TelnetMailReceive {
	private final String POP3_HOST = "pop3.host";	//	Beispiel	"mail.joller-voss.ch"; // eingehend
	private final int POP3_PORT = 110;
	private final boolean DEBUG = true;
	public static void main(String[] args) {
		TelnetMailReceive tel = new TelnetMailReceive();
		String line = "";
		String match = "";
		try {

			// Senden
			Socket sok = new Socket(tel.POP3_HOST, tel.POP3_PORT);

			// einloggen in die Mailbox
			BufferedWriter bw =
				new BufferedWriter(
					new OutputStreamWriter(sok.getOutputStream()));

			// Antwort
			BufferedReader br =
				new BufferedReader(new InputStreamReader(sok.getInputStream()));

			line="\r\n";
			if (tel.DEBUG) System.out.print(line);
			bw.write(line);
			
			// Antwort vom Mail Server 		: +OK POP3 reo0022.wsbox.ch v2003.83rh server ready	
			line="";
			line=br.readLine();
			System.out.println(line);

			// UID
			line = "USER benutzername";						// Beispiel "USER joller@joller-voss.ch\r\n";
			if (tel.DEBUG) System.out.print(line);
			bw.write(line);
			bw.flush();
			
			// Antwort vom Mail Server			
			line="";
			match = "password please";
			while ((line=br.readLine()).indexOf(match)<0) {
				System.out.println(line);
			}
			
			// PWD
			line = "PASS mein_passwort"; 					// Beispiel "PASS xyz\r\n";
			if (tel.DEBUG) System.out.print(line);
			bw.write(line);
			bw.flush();

			// Antwort vom Mail Server
			line="";
			match = "+OK";
			while((line=br.readLine()).indexOf(match)<0) {
				System.out.println(line);
			}

			// Mailbox lesen
			line = "LIST\r\n";
			if (tel.DEBUG) System.out.print(line);
			bw.write(line);
			bw.flush();

			line="";
			match =".";
			do {
				line=br.readLine();
				System.out.println(line);
			} while(line.indexOf(match)<0); 

			System.out.println("[ENDE]");

		} catch (UnknownHostException e) {
			System.err.println(tel.POP3_HOST + " nicht gefunden");
			e.printStackTrace();
		} catch (IOException e) {
			System.err.println(
				"Fehler bei der Verbindung mit " + tel.POP3_HOST);
			e.printStackTrace();
		}
	}
}
