/*
 * Created on 29.02.2004
 * TelnetMail
 *
*/
package telnet;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.Socket;
import java.net.UnknownHostException;

/**
 * @author jjoller
 *
 */
public class TelnetMailSend {
	private final String HOST = "mail.host";		// Beispiel "smtp.swissonline.ch";
	private int PORT = 25;
	private final String TO = "mail_receiver@host"; //Beispiel "joller@joller-voss.ch";
	private final String FROM = "mail_sender@host";	//Beispiel "josef.m.joller@swissonline.ch";
	private final boolean DEBUG = true;
	public static void main(String[] args) {
		TelnetMailSend tel = new TelnetMailSend();
		String line = "";
		String match = "";
		try {
			Socket sok = new Socket(tel.HOST, tel.PORT);

			BufferedWriter bw =
				new BufferedWriter(
					new OutputStreamWriter(sok.getOutputStream()));
			BufferedReader br =
				new BufferedReader(new InputStreamReader(sok.getInputStream()));
			line = "Helo " + tel.HOST + "\r\n";
			if (tel.DEBUG)
				System.out.println("[HELO]" + line);
			bw.write(line);
			bw.flush();
			match = "pleased to meet you";
			while ((line = br.readLine()).indexOf(match) <0) {
				if (tel.DEBUG)
					System.out.println("[HELO]" + line);
			}

			line = "MAIL FROM:<" + tel.FROM + ">\r\n";
			if (tel.DEBUG)
				System.out.println("[MAIL FROM]" + line);
			bw.write(line);
			bw.flush();
			line = "";
			match = "ok";
			while ((line = br.readLine().toLowerCase()).indexOf(match)<0) {
				if (tel.DEBUG)
					System.out.println("[MAIL FROM]" + line);
			}

			line = "RCPT TO:" + tel.TO + "\r\n";
			if (tel.DEBUG)
				System.out.println("[RCPT]" + line);
			bw.write(line);
			bw.flush();
			line = "";
			match = "ok";
			while ((line = br.readLine().toLowerCase()).indexOf(match)<0) {
				System.out.println("[RCPT]" + line);
			}

			line = "DATA\r\n";
			if (tel.DEBUG) System.out.println("[DATA]" + line);
			bw.write(line);
			bw.flush();
			line = "";
			match = "itself";
			while ((line = br.readLine().toLowerCase()).indexOf(match)<0) {
				if (tel.DEBUG)
					System.out.println("[DATA]" + line);
			}
			
			line = "Subject:Test\r\n"+"Test!\r\n"+"\r\n"+"."+"\r\n"+"QUIT\r\n";
			if (tel.DEBUG) System.out.println("[DATA]" + line);
			bw.write(line);
			bw.flush();
			bw.close();
			System.out.println("[ENDE_MAIL]");

		} catch (UnknownHostException e) {
			System.err.println(tel.HOST + " nicht gefunden");
			e.printStackTrace();
		} catch (IOException e) {
			System.err.println("Fehler bei der Verbindung mit " + tel.HOST);
			e.printStackTrace();
		}
	}
}
