package zusatzBeispiele;

/**
 * Title:        Lesen aller Header
 */
import java.util.Enumeration;
import java.util.Properties;

import javax.mail.Folder;
import javax.mail.Header;
import javax.mail.Message;
import javax.mail.Session;
import javax.mail.URLName;

public class LesenAllerHeaderClient {
	private static final String TARGET = "pop3://fam_joller@pop.bluewin.ch/INBOX";
	public static void main(String[] args) {
		String mail;
		if (args.length == 0) {
			System.err.println(
				"Usage: java LesenAllerClient protocol://username@host:port/foldername");
			//return;
			mail = TARGET;
		} else {
			mail = args[0];
		}
		System.out.println("[LesenAllerHeaderClient]main()");
		URLName server = new URLName(mail);
		System.out.println("[LesenAllerHeaderClient.main()]url : "+mail);
		try {

			System.out.println("[LesenAllerHeaderClient.main()]Session");
			Session session =
				Session.getDefaultInstance(
					new Properties(),
					new MailAuthenticator(server.getUsername()));

			// Verbindungsaufbau
			System.out.println("[LesenAllerHeaderClient.main()]Folder");
			Folder folder = session.getFolder(server);
			if (folder == null) {
				System.out.println(
					"Folder " + server.getFile() + " nicht gefunden.");
				System.exit(1);
			}
			folder.open(Folder.READ_ONLY);

			// Lesen der Nachrichten
			System.out.println("[LesenAllerHeaderClient.main()]Message[]");
			Message[] messages = folder.getMessages();
			for (int i = 0; i < messages.length; i++) {
				System.out.println(
					"------------ Message " + (i + 1) + " ------------");
				// Unterschied
				Enumeration headers = messages[i].getAllHeaders();
				while (headers.hasMoreElements()) {
					Header h = (Header) headers.nextElement();
					System.out.println(h.getName() + ": " + h.getValue());
				}
				System.out.println();
			}
			// Verbindungsabbau
			// Nachrichten bleiben auf dem Server
			System.out.println("[LesenAllerHeaderClient.main()]folder.close()");
			folder.close(false);
		} catch (Exception e) {
			e.printStackTrace();
		}
		System.out.println("[LesenAllerHeaderClient.main()]exit");
		System.exit(0); // muss da stehen, sonst wartet das GUI auf neuen Input
	}
}